
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Export_service_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const export_service_items = await db.export_service_items.create(
            {
                id: data.id || undefined,
        
        service_title: data.service_title
        ||
        null
            ,
            
        service_description: data.service_description
        ||
        null
            ,
            
        icon_name: data.icon_name
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return export_service_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const export_service_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                service_title: item.service_title
            ||
            null
            ,
            
                service_description: item.service_description
            ||
            null
            ,
            
                icon_name: item.icon_name
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const export_service_items = await db.export_service_items.bulkCreate(export_service_itemsData, { transaction });

        // For each item created, replace relation files
        

        return export_service_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const export_service_items = await db.export_service_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.service_title !== undefined) updatePayload.service_title = data.service_title;
        
        
        if (data.service_description !== undefined) updatePayload.service_description = data.service_description;
        
        
        if (data.icon_name !== undefined) updatePayload.icon_name = data.icon_name;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await export_service_items.update(updatePayload, {transaction});

        
        

        
        

        

        return export_service_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const export_service_items = await db.export_service_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of export_service_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of export_service_items) {
                await record.destroy({transaction});
            }
        });


        return export_service_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const export_service_items = await db.export_service_items.findByPk(id, options);

        await export_service_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await export_service_items.destroy({
            transaction
        });

        return export_service_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const export_service_items = await db.export_service_items.findOne(
            { where },
            { transaction },
        );

        if (!export_service_items) {
            return export_service_items;
        }

        const output = export_service_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.service_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'export_service_items',
                        'service_title',
                        filter.service_title,
                    ),
                };
            }
            
            if (filter.service_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'export_service_items',
                        'service_description',
                        filter.service_description,
                    ),
                };
            }
            
            if (filter.icon_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'export_service_items',
                        'icon_name',
                        filter.icon_name,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.export_service_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'export_service_items',
                        'service_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.export_service_items.findAll({
            attributes: [ 'id', 'service_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['service_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.service_title,
        }));
    }

    
};

